
_I2C_LCD_Cmd:

;TWI LCD.mbas,33 :: 		Dim rs as byte
;TWI LCD.mbas,35 :: 		rs = 0
; rs start address is: 17 (R17)
	LDI        R17, 0
;TWI LCD.mbas,37 :: 		hi_n = out_char and $F0
	MOV        R16, R2
	ANDI       R16, 240
; hi_n start address is: 18 (R18)
	MOV        R18, R16
;TWI LCD.mbas,38 :: 		lo_n = (out_char << 4) and $F0
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 19 (R19)
	MOV        R19, R16
;TWI LCD.mbas,40 :: 		TWI_Start()
	PUSH       R17
	CALL       _TWI_Start+0
	POP        R17
;TWI LCD.mbas,41 :: 		TWI_Write(LCD_ADDR)
	PUSH       R2
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;TWI LCD.mbas,42 :: 		TWI_Write(hi_n or rs or $04 or $08)
	MOV        R16, R18
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,43 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Cmd1:
	DEC        R16
	BRNE       L__I2C_LCD_Cmd1
	NOP
	NOP
;TWI LCD.mbas,44 :: 		TWI_Write(hi_n or rs or $00 or $08)
	MOV        R16, R18
	OR         R16, R17
; hi_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,45 :: 		Delay_us(100)
	LDI        R16, 133
L__I2C_LCD_Cmd3:
	DEC        R16
	BRNE       L__I2C_LCD_Cmd3
	NOP
;TWI LCD.mbas,46 :: 		TWI_Write(lo_n or rs or $04 or $08)
	MOV        R16, R19
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,47 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Cmd5:
	DEC        R16
	BRNE       L__I2C_LCD_Cmd5
	NOP
	NOP
;TWI LCD.mbas,48 :: 		TWI_Write(lo_n or rs or $00 or $08)
	MOV        R16, R19
	OR         R16, R17
; rs end address is: 17 (R17)
; lo_n end address is: 19 (R19)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
	POP        R2
;TWI LCD.mbas,49 :: 		TWI_stop()
	CALL       _TWI_Stop+0
;TWI LCD.mbas,51 :: 		if(out_char = $01) then
	LDI        R27, 1
	CP         R2, R27
	BREQ       L__I2C_LCD_Cmd79
	JMP        L__I2C_LCD_Cmd8
L__I2C_LCD_Cmd79:
;TWI LCD.mbas,52 :: 		Delay_ms(2)
	LDI        R17, 11
	LDI        R16, 99
L__I2C_LCD_Cmd10:
	DEC        R16
	BRNE       L__I2C_LCD_Cmd10
	DEC        R17
	BRNE       L__I2C_LCD_Cmd10
L__I2C_LCD_Cmd8:
;TWI LCD.mbas,54 :: 		end sub
L_end_I2C_LCD_Cmd:
	RET
; end of _I2C_LCD_Cmd

_I2C_LCD_Chr:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;TWI LCD.mbas,59 :: 		Dim rs as byte
;TWI LCD.mbas,61 :: 		rs = 1
	PUSH       R2
	LDI        R27, 1
	STD        Y+0, R27
;TWI LCD.mbas,65 :: 		case 1
	LDI        R27, 1
	CP         R2, R27
	BREQ       L__I2C_LCD_Chr81
	JMP        L__I2C_LCD_Chr16
L__I2C_LCD_Chr81:
;TWI LCD.mbas,66 :: 		I2C_LCD_Cmd($80 + (column - 1))
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 128
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	JMP        L__I2C_LCD_Chr13
L__I2C_LCD_Chr16:
;TWI LCD.mbas,67 :: 		case 2
	LDI        R27, 2
	CP         R2, R27
	BREQ       L__I2C_LCD_Chr82
	JMP        L__I2C_LCD_Chr19
L__I2C_LCD_Chr82:
;TWI LCD.mbas,68 :: 		I2C_LCD_Cmd($C0 + (column - 1))
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 64
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	JMP        L__I2C_LCD_Chr13
L__I2C_LCD_Chr19:
;TWI LCD.mbas,69 :: 		case 3
	LDI        R27, 3
	CP         R2, R27
	BREQ       L__I2C_LCD_Chr83
	JMP        L__I2C_LCD_Chr22
L__I2C_LCD_Chr83:
;TWI LCD.mbas,70 :: 		I2C_LCD_Cmd($94 + (column - 1))
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 108
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	JMP        L__I2C_LCD_Chr13
L__I2C_LCD_Chr22:
;TWI LCD.mbas,71 :: 		case 4
	LDI        R27, 4
	CP         R2, R27
	BREQ       L__I2C_LCD_Chr84
	JMP        L__I2C_LCD_Chr25
L__I2C_LCD_Chr84:
;TWI LCD.mbas,72 :: 		I2C_LCD_Cmd($D4 + (column - 1))
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 44
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	JMP        L__I2C_LCD_Chr13
L__I2C_LCD_Chr25:
L__I2C_LCD_Chr13:
;TWI LCD.mbas,75 :: 		hi_n = out_char and $F0
	MOV        R16, R4
	ANDI       R16, 240
; hi_n start address is: 17 (R17)
	MOV        R17, R16
;TWI LCD.mbas,76 :: 		lo_n = (out_char << 4) and $F0
	MOV        R16, R4
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 18 (R18)
	MOV        R18, R16
;TWI LCD.mbas,78 :: 		TWI_Start()
	PUSH       R17
	CALL       _TWI_Start+0
	POP        R17
;TWI LCD.mbas,79 :: 		TWI_Write(LCD_ADDR)
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;TWI LCD.mbas,80 :: 		TWI_Write(hi_n or rs or $04 or $08)
	LDD        R16, Y+0
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,81 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Chr26:
	DEC        R16
	BRNE       L__I2C_LCD_Chr26
	NOP
	NOP
;TWI LCD.mbas,82 :: 		TWI_Write(hi_n or rs or $00 or $08)
	LDD        R16, Y+0
	OR         R16, R17
; hi_n end address is: 17 (R17)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,83 :: 		Delay_us(100)
	LDI        R16, 133
L__I2C_LCD_Chr28:
	DEC        R16
	BRNE       L__I2C_LCD_Chr28
	NOP
;TWI LCD.mbas,84 :: 		TWI_Write(lo_n or rs or $04 or $08)
	LDD        R16, Y+0
	OR         R16, R18
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,85 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Chr30:
	DEC        R16
	BRNE       L__I2C_LCD_Chr30
	NOP
	NOP
;TWI LCD.mbas,86 :: 		TWI_Write(lo_n or rs or $00 or $08)
	LDD        R16, Y+0
	OR         R16, R18
; lo_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,87 :: 		TWI_stop()
	CALL       _TWI_Stop+0
;TWI LCD.mbas,88 :: 		end sub
L_end_I2C_LCD_Chr:
	POP        R2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Chr

_I2C_LCD_Chr_Cp:

;TWI LCD.mbas,93 :: 		Dim rs as byte
;TWI LCD.mbas,95 :: 		rs = $01
	PUSH       R2
; rs start address is: 17 (R17)
	LDI        R17, 1
;TWI LCD.mbas,97 :: 		hi_n = out_char and $F0
	MOV        R16, R2
	ANDI       R16, 240
; hi_n start address is: 18 (R18)
	MOV        R18, R16
;TWI LCD.mbas,98 :: 		lo_n = (out_char << 4) and $F0
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 19 (R19)
	MOV        R19, R16
;TWI LCD.mbas,100 :: 		TWI_Start()
	PUSH       R17
	CALL       _TWI_Start+0
	POP        R17
;TWI LCD.mbas,101 :: 		TWI_Write(LCD_ADDR)
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;TWI LCD.mbas,102 :: 		TWI_Write(hi_n or rs or $04 or $08)
	MOV        R16, R18
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,103 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Chr_Cp33:
	DEC        R16
	BRNE       L__I2C_LCD_Chr_Cp33
	NOP
	NOP
;TWI LCD.mbas,104 :: 		TWI_Write(hi_n or rs or $00 or $08)
	MOV        R16, R18
	OR         R16, R17
; hi_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,105 :: 		Delay_us(100)
	LDI        R16, 133
L__I2C_LCD_Chr_Cp35:
	DEC        R16
	BRNE       L__I2C_LCD_Chr_Cp35
	NOP
;TWI LCD.mbas,106 :: 		TWI_Write(lo_n or rs or $04 or $08)
	MOV        R16, R19
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,107 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Chr_Cp37:
	DEC        R16
	BRNE       L__I2C_LCD_Chr_Cp37
	NOP
	NOP
;TWI LCD.mbas,108 :: 		TWI_Write(lo_n or rs or $00 or $08)
	MOV        R16, R19
	OR         R16, R17
; rs end address is: 17 (R17)
; lo_n end address is: 19 (R19)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,109 :: 		TWI_stop()
	CALL       _TWI_Stop+0
;TWI LCD.mbas,110 :: 		end sub
L_end_I2C_LCD_Chr_Cp:
	POP        R2
	RET
; end of _I2C_LCD_Chr_Cp

_I2C_LCD_Init:

;TWI LCD.mbas,115 :: 		Dim rs as byte
;TWI LCD.mbas,116 :: 		Delay_ms(150)
	PUSH       R2
	LDI        R18, 4
	LDI        R17, 12
	LDI        R16, 52
L__I2C_LCD_Init40:
	DEC        R16
	BRNE       L__I2C_LCD_Init40
	DEC        R17
	BRNE       L__I2C_LCD_Init40
	DEC        R18
	BRNE       L__I2C_LCD_Init40
	NOP
	NOP
;TWI LCD.mbas,118 :: 		rs = 0
; rs start address is: 17 (R17)
	LDI        R17, 0
;TWI LCD.mbas,120 :: 		TWI_Start()
	PUSH       R17
	CALL       _TWI_Start+0
	POP        R17
;TWI LCD.mbas,121 :: 		TWI_Write(LCD_ADDR)
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;TWI LCD.mbas,123 :: 		TWI_Write($30 or rs or $04 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,124 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Init42:
	DEC        R16
	BRNE       L__I2C_LCD_Init42
	NOP
	NOP
;TWI LCD.mbas,125 :: 		TWI_Write($30 or rs or $00 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,126 :: 		Delay_ms(30)
	PUSH       R17
	LDI        R17, 156
	LDI        R16, 215
L__I2C_LCD_Init44:
	DEC        R16
	BRNE       L__I2C_LCD_Init44
	DEC        R17
	BRNE       L__I2C_LCD_Init44
	NOP
	NOP
	POP        R17
;TWI LCD.mbas,128 :: 		TWI_Write($30 or rs or $04 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,129 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Init46:
	DEC        R16
	BRNE       L__I2C_LCD_Init46
	NOP
	NOP
;TWI LCD.mbas,130 :: 		TWI_Write($30 or rs or $00 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,131 :: 		Delay_ms(30)
	PUSH       R17
	LDI        R17, 156
	LDI        R16, 215
L__I2C_LCD_Init48:
	DEC        R16
	BRNE       L__I2C_LCD_Init48
	DEC        R17
	BRNE       L__I2C_LCD_Init48
	NOP
	NOP
	POP        R17
;TWI LCD.mbas,133 :: 		TWI_Write($30 or rs or $04 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,134 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Init50:
	DEC        R16
	BRNE       L__I2C_LCD_Init50
	NOP
	NOP
;TWI LCD.mbas,135 :: 		TWI_Write($30 or rs or $00 or $08)
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,136 :: 		Delay_ms(30)
	PUSH       R17
	LDI        R17, 156
	LDI        R16, 215
L__I2C_LCD_Init52:
	DEC        R16
	BRNE       L__I2C_LCD_Init52
	DEC        R17
	BRNE       L__I2C_LCD_Init52
	NOP
	NOP
	POP        R17
;TWI LCD.mbas,138 :: 		TWI_Write($20 or rs or $04 or $08)
	MOV        R16, R17
	ORI        R16, 32
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,139 :: 		Delay_us(50)
	LDI        R16, 66
L__I2C_LCD_Init54:
	DEC        R16
	BRNE       L__I2C_LCD_Init54
	NOP
	NOP
;TWI LCD.mbas,140 :: 		TWI_Write($20 or rs or $00 or $08)
	MOV        R16, R17
	ORI        R16, 32
; rs end address is: 17 (R17)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;TWI LCD.mbas,141 :: 		TWI_Stop()
	CALL       _TWI_Stop+0
;TWI LCD.mbas,143 :: 		Delay_ms(20)
	LDI        R17, 104
	LDI        R16, 229
L__I2C_LCD_Init56:
	DEC        R16
	BRNE       L__I2C_LCD_Init56
	DEC        R17
	BRNE       L__I2C_LCD_Init56
;TWI LCD.mbas,145 :: 		I2C_LCD_Cmd($28)
	LDI        R27, 40
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;TWI LCD.mbas,146 :: 		I2C_LCD_Cmd($06)
	LDI        R27, 6
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;TWI LCD.mbas,147 :: 		end sub
L_end_I2C_LCD_Init:
	POP        R2
	RET
; end of _I2C_LCD_Init

_I2C_LCD_Out:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;TWI LCD.mbas,150 :: 		Dim i as byte
;TWI LCD.mbas,152 :: 		for i = 0 to Strlen(text) - 1
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L__I2C_LCD_Out59:
; i start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R2, R4
	CALL       _strlen+0
	POP        R2
	POP        R3
	SUBI       R16, 1
	SBCI       R17, 0
	STD        Y+0, R16
	STD        Y+1, R17
	CP         R16, R20
	LDI        R27, 0
	CPC        R17, R27
	BRSH       L__I2C_LCD_Out88
	JMP        L__I2C_LCD_Out63
L__I2C_LCD_Out88:
;TWI LCD.mbas,153 :: 		I2C_LCD_Chr(row, column, text[i])
	MOV        R30, R20
	LDI        R31, 0
	ADD        R30, R4
	ADC        R31, R5
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	MOV        R4, R16
	CALL       _I2C_LCD_Chr+0
	POP        R4
	POP        R5
;TWI LCD.mbas,154 :: 		column = column + 1
	MOV        R16, R3
	SUBI       R16, 255
	MOV        R3, R16
;TWI LCD.mbas,155 :: 		next i
	MOV        R18, R20
	LDI        R19, 0
	LDD        R16, Y+0
	LDD        R17, Y+1
	CP         R18, R16
	CPC        R19, R17
	BRNE       L__I2C_LCD_Out89
	JMP        L__I2C_LCD_Out63
L__I2C_LCD_Out89:
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
; i end address is: 20 (R20)
	JMP        L__I2C_LCD_Out59
L__I2C_LCD_Out63:
;TWI LCD.mbas,156 :: 		end sub
L_end_I2C_LCD_Out:
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Out

_I2C_LCD_Out_Cp:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;TWI LCD.mbas,159 :: 		Dim i as byte
;TWI LCD.mbas,161 :: 		for i = 0 to Strlen(text) - 1
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L__I2C_LCD_Out_Cp65:
; i start address is: 20 (R20)
	CALL       _strlen+0
	SUBI       R16, 1
	SBCI       R17, 0
	STD        Y+0, R16
	STD        Y+1, R17
	CP         R16, R20
	LDI        R27, 0
	CPC        R17, R27
	BRSH       L__I2C_LCD_Out_Cp91
	JMP        L__I2C_LCD_Out_Cp69
L__I2C_LCD_Out_Cp91:
;TWI LCD.mbas,162 :: 		I2C_LCD_Chr_Cp(text[i])
	MOV        R30, R20
	LDI        R31, 0
	ADD        R30, R2
	ADC        R31, R3
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
	POP        R2
	POP        R3
;TWI LCD.mbas,163 :: 		next i
	MOV        R18, R20
	LDI        R19, 0
	LDD        R16, Y+0
	LDD        R17, Y+1
	CP         R18, R16
	CPC        R19, R17
	BRNE       L__I2C_LCD_Out_Cp92
	JMP        L__I2C_LCD_Out_Cp69
L__I2C_LCD_Out_Cp92:
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
; i end address is: 20 (R20)
	JMP        L__I2C_LCD_Out_Cp65
L__I2C_LCD_Out_Cp69:
;TWI LCD.mbas,164 :: 		end sub
L_end_I2C_LCD_Out_Cp:
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Out_Cp

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;TWI LCD.mbas,166 :: 		main:
;TWI LCD.mbas,168 :: 		DDRC = 0xFF
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 255
	OUT        DDRC+0, R27
;TWI LCD.mbas,170 :: 		txt1 = "TWI LCD"
	LDI        R30, #lo_addr(_txt1+0)
	LDI        R31, hi_addr(_txt1+0)
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 87
	ST         Z+, R27
	LDI        R27, 73
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 76
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 68
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;TWI LCD.mbas,171 :: 		txt2 = "16x2, 20x2, 20x4"
	LDI        R30, #lo_addr(_txt2+0)
	LDI        R31, hi_addr(_txt2+0)
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 54
	ST         Z+, R27
	LDI        R27, 120
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 44
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 120
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 44
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 120
	ST         Z+, R27
	LDI        R27, 52
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;TWI LCD.mbas,172 :: 		txt3 = "ATMEGA8"
	LDI        R30, #lo_addr(_txt3+0)
	LDI        R31, hi_addr(_txt3+0)
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 77
	ST         Z+, R27
	LDI        R27, 69
	ST         Z+, R27
	LDI        R27, 71
	ST         Z+, R27
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 56
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;TWI LCD.mbas,173 :: 		txt4 = "4 MHz"
	LDI        R30, #lo_addr(_txt4+0)
	LDI        R31, hi_addr(_txt4+0)
	LDI        R27, 52
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 77
	ST         Z+, R27
	LDI        R27, 72
	ST         Z+, R27
	LDI        R27, 122
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;TWI LCD.mbas,175 :: 		TWI_Init(100000)
	IN         R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	OUT        TWPS0_bit+0, R27
	IN         R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	OUT        TWPS1_bit+0, R27
	LDI        R27, 12
	OUT        TWBR+0, R27
	CALL       _TWI_Init+0
;TWI LCD.mbas,176 :: 		Delay_ms(200)
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L__main71:
	DEC        R16
	BRNE       L__main71
	DEC        R17
	BRNE       L__main71
	DEC        R18
	BRNE       L__main71
;TWI LCD.mbas,178 :: 		I2C_LCD_Init()
	CALL       _I2C_LCD_Init+0
;TWI LCD.mbas,179 :: 		I2C_LCD_Cmd(_LCD_CURSOR_OFF)
	LDI        R27, 12
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;TWI LCD.mbas,180 :: 		I2C_LCD_Cmd(_LCD_CLEAR)
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;TWI LCD.mbas,181 :: 		I2C_Lcd_Out(1,1,txt1)                 ' Write text in first row
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;TWI LCD.mbas,182 :: 		I2C_Lcd_Out(2,1,txt2)                 ' Write text in second row
	LDI        R27, #lo_addr(_txt2+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt2+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;TWI LCD.mbas,183 :: 		I2C_Lcd_Out(3,1,txt3)                 ' Write text in third row
	LDI        R27, #lo_addr(_txt3+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt3+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 3
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;TWI LCD.mbas,184 :: 		I2C_Lcd_Out(4,1,txt4)                 ' Write text in fourth row
	LDI        R27, #lo_addr(_txt4+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt4+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;TWI LCD.mbas,186 :: 		while(TRUE)
L__main74:
	JMP        L__main74
;TWI LCD.mbas,188 :: 		Wend
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
